"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mapping_1 = __importDefault(require("./mapping"));
var utils_1 = require("./utils");
var TypeMapper = /** @class */ (function () {
    function TypeMapper() {
        this.mappings = [];
    }
    TypeMapper.prototype.createMap = function () {
        var mapping = new mapping_1.default();
        this.mappings.push(mapping);
        return mapping;
    };
    TypeMapper.prototype.map = function (source, destination) {
        var mapping = this.mappings[0];
        var i = mapping;
        var items = i.items;
        for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
            var item = items_1[_i];
            var sourcePredicate = item.sourcePredicate, destinationPredicate = item.destinationPredicate;
            var sourceKey = utils_1.getKeyFromPredicate(sourcePredicate);
            var destinationKey = utils_1.getKeyFromPredicate(destinationPredicate);
            var rawValue = source[sourceKey];
            var typedValue = utils_1.toType(typeof rawValue, rawValue);
            destination[destinationKey] = typedValue;
        }
        return destination;
    };
    TypeMapper.prototype.mapCollection = function (sources, destination) {
        var _this = this;
        return sources.map(function (source) { return _this.map(source, destination); });
    };
    return TypeMapper;
}());
exports.TypeMapper = TypeMapper;
//# sourceMappingURL=typemapper.js.map